#ifndef SCRIPT_HPP_INCLUDED
#define SCRIPT_HPP_INCLUDED

#include <string>
#include <vector>
#include "Types/Timer.hpp"

extern void Setup();
extern bool OnStart();
extern bool Loop();

typedef struct
{
    std::string Name = "";
    std::string Description = "";
    std::string Version = "";
    std::string Category = "";
    std::string Author = "";
    std::string UID = "";
    std::string ForumPage = "";
} ScriptInfo;

typedef struct
{
    std::string Username;
    std::string Password;
    bool Member;
    bool HasPin;
    std::string BankPin;
    std::string World;
    bool UseProxy;
    std::string ProxyHost;
    std::string ProxyPort;
    std::string ProxyUsername;
    std::string ProxyPassword;
    std::int32_t ActionDelayMean;
    float ActionDelayDeviation;
    std::int32_t MoveDelayMean;
    float MoveDelayDeviation;
    std::int32_t MouseDownDelayMean;
    float MouseDownDelayDeviation;
    std::int32_t MouseUpDelayMean;
    float MouseUpDelayDeviation;
    std::int32_t KeyDownDelayMean;
    float KeyDownDelayDeviation;
    std::int32_t KeyUpDelayMean;
    float KeyUpDelayDeviation;
    std::int32_t ScrollDelayMean;
    float ScrollDelayDeviation;
    float StandardDeviationX;
    float StandardDeviationY;
    float BoxProbabilityX;
    float BoxProbabilityY;
    float ConvexProbabilityX;
    float ConvexProbabilityY;
    float ItemProbabilityX;
    float ItemProbabilityY;
    float MenuProbabilityX;
    float MenuProbabilityY;
    float WidgetProbabilityX;
    float WidgetProbabilityY;
    float MissFollowUp;
    float FatigueGain;
    float FatigueLoss;
    float FatigueMax;
    bool ShortBreakEnabled;
    float ShortBreakEvery;
    float ShortBreakEveryDeviation;
    float ShortBreakFor;
    float ShortBreakForDeviation;
    bool LongBreakEnabled;
    float LongBreakEvery;
    float LongBreakEveryDeviation;
    float LongBreakFor;
    float LongBreakForDeviation;
} PlayerProfile;

Timer GetScriptTimer();
void SetScriptInfo(ScriptInfo);
void GetScriptInfo(ScriptInfo&);
void SetPlayerProfile(PlayerProfile);
void RequestArgument(std::string Argument, std::string Description);
std::vector<std::string> GetArguments();
std::vector<std::string> GetArgumentDescriptions();
void SetArgument(std::string Argument, std::string Value);
std::string GetArgument(std::string Argument);
std::uint32_t GetLoopDelay();
void SetLoopDelay(std::uint32_t Delay);

#endif // SCRIPT_HPP_INCLUDED
