#ifndef INTERACTABLEGAMEOBJECT_HPP_INCLUDED
#define INTERACTABLEGAMEOBJECT_HPP_INCLUDED

#include "../../Core/Classes/GameObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Convex.hpp"
#include <cstdint>

namespace Interactable
{
    class GameObject : public Internal::GameObject
    {
        public:
            GameObject(const Internal::GameObject& G);
            GameObject(const GameObject& G);

            std::int32_t GetID() const;
            std::string GetName() const;
            Tile GetTile() const;
            Internal::ObjectInfo GetInfo() const;
            std::vector<Point> GetModel() const;
            Convex GetConvex() const;

    };
}

#endif // INTERACTABLEGAMEOBJECT_HPP_INCLUDED
