#ifndef MINIMAP_HPP_INCLUDED
#define MINIMAP_HPP_INCLUDED

#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Classes/Region.hpp"
#include <cstdint>

/** @addtogroup Interfaces
* @{ */
class Minimap
{
    public:
        static Point GetMiddle();
        static Tile GetPosition();

        static std::int32_t GetPlane();
        static std::int32_t GetPositionX();
        static std::int32_t GetPositionY();

        static Tile GetDestination();
        static std::int32_t GetDestinationX();
        static std::int32_t GetDestinationY();

        static bool CloseTo(Tile T, std::int32_t Distance);
        static bool TileOnMM(Tile T);

        static double GetCompassAngle();
        static void RotateCompass(std::int32_t Degrees);
};

/** @} */

#endif // MINIMAP_HPP_INCLUDED
