#ifndef GAMEOBJECTS_HPP_INCLUDED
#define GAMEOBJECTS_HPP_INCLUDED

#include "../../Core/Classes/GameObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GameObjects
{
    public:

        static Internal::ObjectInfo GetInfoOf(const Internal::GameObject& G);
        static Tile GetTileOf(const Internal::GameObject& G);
        static std::vector<Point> GetModelOf(const Internal::GameObject& G);
        static Convex GetConvexOf(const Internal::GameObject& G);

        //consider changing to Interactable::GameObject
        static std::vector<Internal::GameObject> GetAll();
        static std::vector<Internal::GameObject> GetAll(const Tile& T);
        static std::vector<Internal::GameObject> GetAll(std::int32_t ID);
        static std::vector<Internal::GameObject> GetAll(const std::string& Name);
        static std::vector<Internal::GameObject> GetAll(const std::vector<std::int32_t>& PossibleIDs);
        static std::vector<Internal::GameObject> GetAll(const std::vector<std::string>& PossibleNames);
        static std::vector<Internal::GameObject> GetAll(const std::function<bool (const Internal::GameObject&)>& Filter);

        static Internal::GameObject Get(const Tile& T);
        static Internal::GameObject Get(std::int32_t ID);
        static Internal::GameObject Get(const std::string& Name);
        static Internal::GameObject Get(const std::vector<std::int32_t>& PossibleIDs);
        static Internal::GameObject Get(const std::vector<std::string>& PossibleNames);
        static Internal::GameObject Get(const std::function<bool (const Internal::GameObject&)>& Filter);
};

/** @} */

#endif // GAMEOBJECTS_HPP_INCLUDED
