#ifndef GROUNDOBJECTS_HPP_INCLUDED
#define GROUNDOBJECTS_HPP_INCLUDED

#include "../../Core/Classes/GroundObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class GroundObjects
{
    public:

        static Internal::ObjectInfo GetInfoOf(const Internal::GroundObject& G);
        static Tile GetTileOf(const Internal::GroundObject& G);
        static std::vector<Point> GetModelOf(const Internal::GroundObject& G);
        static Convex GetConvexOf(const Internal::GroundObject& G);

        //consider changing to Interactable::GameObject
        static std::vector<Internal::GroundObject> GetAll();
        static std::vector<Internal::GroundObject> GetAll(std::int32_t ID);
        static std::vector<Internal::GroundObject> GetAll(const std::string& Name);
        static std::vector<Internal::GroundObject> GetAll(const std::vector<std::int32_t>& PossibleIDs);
        static std::vector<Internal::GroundObject> GetAll(const std::vector<std::string>& PossibleNames);
        static std::vector<Internal::GroundObject> GetAll(const std::function<bool (const Internal::GroundObject&)>& Filter);

        static Internal::GroundObject Get(const Tile& T);
        static Internal::GroundObject Get(std::int32_t ID);
        static Internal::GroundObject Get(const std::string& Name);
        static Internal::GroundObject Get(const std::vector<std::int32_t>& PossibleIDs);
        static Internal::GroundObject Get(const std::vector<std::string>& PossibleNames);
        static Internal::GroundObject Get(const std::function<bool (const Internal::GroundObject&)>& Filter);
};

/** @} */

#endif // GROUNDOBJECTS_HPP_INCLUDED
