#ifndef WALLOBJECTS_HPP_INCLUDED
#define WALLOBJECTS_HPP_INCLUDED

#include "../../Core/Classes/WallObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class WallObjects
{
    public:

        static Internal::ObjectInfo GetInfoOf(const Internal::WallObject& W);
        static Tile GetTileOf(const Internal::WallObject& W);
        static std::vector<Point> GetModelOf(const Internal::WallObject& W);
        static Convex GetConvexOf(const Internal::WallObject& W);

        //consider changing to Interactable::GameObject
        static std::vector<Internal::WallObject> GetAll();
        static std::vector<Internal::WallObject> GetAll(std::int32_t ID);
        static std::vector<Internal::WallObject> GetAll(const std::string& Name);
        static std::vector<Internal::WallObject> GetAll(const std::vector<std::int32_t>& PossibleIDs);
        static std::vector<Internal::WallObject> GetAll(const std::vector<std::string>& PossibleNames);
        static std::vector<Internal::WallObject> GetAll(const std::function<bool (const Internal::WallObject&)>& Filter);

        static Internal::WallObject Get(const Tile& T);
        static Internal::WallObject Get(std::int32_t ID);
        static Internal::WallObject Get(const std::string& Name);
        static Internal::WallObject Get(const std::vector<std::int32_t>& PossibleIDs);
        static Internal::WallObject Get(const std::vector<std::string>& PossibleNames);
        static Internal::WallObject Get(const std::function<bool (const Internal::WallObject&)>& Filter);
};

/** @} */

#endif // WALLOBJECTS_HPP_INCLUDED
